// FT2232CJTAGC++NETTestApp.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <windows.h>

#include "FTCJTAG.h"

int _tmain(int argc, _TCHAR* argv[])
{
  FTC_STATUS Status = FTC_SUCCESS;
  DWORD dwNumDevices = 0;
  char szDeviceName[100];
  DWORD dwLocationID = 0;
  FTC_HANDLE ftHandle;
  DWORD dwClockFrequencyHz = 0;
  FTC_INPUT_OUTPUT_PINS LowInputOutputPinsData;
  FTC_INPUT_OUTPUT_PINS HighInputOutputPinsData;
  FTC_LOW_HIGH_PINS LowPinsInputData;
  FTC_LOW_HIGH_PINS HighPinsInputData;
  BOOL bPerformCommandSequence = false;
  WriteDataByteBuffer WriteDataBuffer;
  ReadDataByteBuffer ReadDataBuffer;
  ReadCmdSequenceDataByteBuffer ReadCmdSequenceDataBuffer;
  DWORD dwNumBytesReturned = 0;
  DWORD dwLoopCntr = 0;
  char szDllVersion[10];
  char szErrorMessage[100];

  Status = JTAG_GetNumDevices(&dwNumDevices);

  Status = JTAG_GetDllVersion(szDllVersion, 10);
  //MessageBox(NULL, szDllVersion, "JTAG DLL Version", MB_OK);

  if ((Status == FTC_SUCCESS) && (dwNumDevices > 0))
  {
    if (dwNumDevices == 1)
    {
      Status = JTAG_GetDeviceNameLocID(0, szDeviceName, 50, &dwLocationID);

      if (Status == FTC_SUCCESS)
      {
        Status = JTAG_OpenEx(szDeviceName, dwLocationID, &ftHandle);
        //Status = JTAG_Open(&ftHandle);
      }
    }
    else
    {
      if (dwNumDevices == 2)
      {
        Status = JTAG_GetDeviceNameLocID(1, szDeviceName, 50, &dwLocationID);

        if (Status == FTC_SUCCESS)
        {
          Status = JTAG_OpenEx(szDeviceName, dwLocationID, &ftHandle);
          //Status = JTAG_Open(&ftHandle);
        }
      }
    }
  }

  if ((Status == FTC_SUCCESS) && (dwNumDevices > 0))
  {
    //Status = JTAG_GetNumDevices(&dwNumDevices);

    Status = JTAG_InitDevice(ftHandle, 0); //65535

    if (Status == FTC_SUCCESS)
      Status = JTAG_GetClock(5, &dwClockFrequencyHz);

    //if (Status == FTC_SUCCESS)
    //  Status = JTAG_SetLoopback(ftHandle, true);

    if (Status == FTC_SUCCESS)
    {
      LowInputOutputPinsData.bPin1InputOutputState = true;
      LowInputOutputPinsData.bPin2InputOutputState = true;
      LowInputOutputPinsData.bPin3InputOutputState = true;
      LowInputOutputPinsData.bPin4InputOutputState = true;
      LowInputOutputPinsData.bPin1LowHighState = true;
      LowInputOutputPinsData.bPin2LowHighState = true;
      LowInputOutputPinsData.bPin3LowHighState = true;
      LowInputOutputPinsData.bPin4LowHighState = true;

      HighInputOutputPinsData.bPin1InputOutputState = true;
      HighInputOutputPinsData.bPin2InputOutputState = true;
      HighInputOutputPinsData.bPin3InputOutputState = true;
      HighInputOutputPinsData.bPin4InputOutputState = true;
      HighInputOutputPinsData.bPin1LowHighState = true;
      HighInputOutputPinsData.bPin2LowHighState = true;
      HighInputOutputPinsData.bPin3LowHighState = true;
      HighInputOutputPinsData.bPin4LowHighState = false;

      Status = JTAG_SetGPIOs(ftHandle, true, &LowInputOutputPinsData, true, &HighInputOutputPinsData);

      if (Status == FTC_SUCCESS)
        Status = JTAG_GetGPIOs(ftHandle, true, &LowPinsInputData, true, &HighPinsInputData);

      if (Status == FTC_SUCCESS)
        Status = JTAG_SetClock(ftHandle, 0, &dwClockFrequencyHz);

      if (Status == FTC_SUCCESS)
      {
        bPerformCommandSequence = true;

        if (bPerformCommandSequence == false)
        {
          do
          {
            WriteDataBuffer[0] = '\x00';
            WriteDataBuffer[1] = '\x00';
            WriteDataBuffer[2] = '\x00';
            WriteDataBuffer[3] = '\x00';
            Status = JTAG_Write(ftHandle, true, 32, &WriteDataBuffer, 4, RUN_TEST_IDLE_STATE);

            if (Status == FTC_SUCCESS)
            {
              Sleep(10);

              Status = JTAG_Read(ftHandle, true, 32, &ReadDataBuffer, &dwNumBytesReturned, RUN_TEST_IDLE_STATE);

              if (Status == FTC_SUCCESS)
                Status = JTAG_WriteRead(ftHandle, true, 524280, &WriteDataBuffer, 65535, &ReadDataBuffer, 
                                        &dwNumBytesReturned, RUN_TEST_IDLE_STATE);
            }

            dwLoopCntr++;
          }
          while ((dwLoopCntr < 10) && (Status == FTC_SUCCESS));
        }
        else
        {
          if (dwNumDevices == 1)
          {
            JTAG_ClearCmdSequence();

            do
            {
              WriteDataBuffer[0] = '\x00';
              WriteDataBuffer[1] = '\x00';
              WriteDataBuffer[2] = '\x00';
              WriteDataBuffer[3] = '\x00';
              Status = JTAG_AddWriteCmd(true, 32, &WriteDataBuffer, 4, RUN_TEST_IDLE_STATE);

              if (Status == FTC_SUCCESS)
              {
                Status = JTAG_AddReadCmd(true, 32, RUN_TEST_IDLE_STATE);

                if (Status == FTC_SUCCESS)
                  Status = JTAG_AddWriteReadCmd(true, 32, &WriteDataBuffer, 4, RUN_TEST_IDLE_STATE);
              }

              dwLoopCntr++;
            }
            while ((dwLoopCntr < 4) && (Status == FTC_SUCCESS));
          }
          else
          {
            JTAG_ClearDeviceCmdSequence(ftHandle);

            do
            {
              WriteDataBuffer[0] = '\x00';
              WriteDataBuffer[1] = '\x00';
              WriteDataBuffer[2] = '\x00';
              WriteDataBuffer[3] = '\x00';
              Status = JTAG_AddDeviceWriteCmd(ftHandle, true, 32, &WriteDataBuffer, 4, RUN_TEST_IDLE_STATE);

              if (Status == FTC_SUCCESS)
              {
                Status = JTAG_AddDeviceReadCmd(ftHandle, true, 32, RUN_TEST_IDLE_STATE);

                if (Status == FTC_SUCCESS)
                  Status = JTAG_AddDeviceWriteReadCmd(ftHandle, true, 32, &WriteDataBuffer, 4, RUN_TEST_IDLE_STATE);
              }

              dwLoopCntr++;
            }
            while ((dwLoopCntr < 4) && (Status == FTC_SUCCESS));
          }

          if (Status == FTC_SUCCESS)
            Status = JTAG_ExecuteCmdSequence(ftHandle, &ReadCmdSequenceDataBuffer, &dwNumBytesReturned);
        }
      }
    }

    JTAG_Close(ftHandle);
  }

  if (Status != FTC_SUCCESS)
  {
    Status = JTAG_GetErrorCodeString("EN", Status, szErrorMessage, 100);

    MessageBox(NULL, szErrorMessage, "JTAG Error Status Message", MB_OK);
  }
  else
  {
    Status = JTAG_GetDllVersion(szDllVersion, 10);

    //if (Status == FTC_SUCCESS)
      //MessageBox(NULL, szDllVersion, "JTAG DLL Version", MB_OK);
    //else
    //{
      //Status = JTAG_GetErrorCodeString("EN", Status, szErrorMessage, 100);

      //MessageBox(NULL, szErrorMessage, "JTAG Error Status Message", MB_OK);
    //}
  }

	return 0;
}

